/*******************************************************************************
* File Name: PWMIN1.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_PWMIN1_H) /* Pins PWMIN1_H */
#define CY_PINS_PWMIN1_H

#include "cytypes.h"
#include "cyfitter.h"
#include "PWMIN1_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    PWMIN1_Write(uint8 value) ;
void    PWMIN1_SetDriveMode(uint8 mode) ;
uint8   PWMIN1_ReadDataReg(void) ;
uint8   PWMIN1_Read(void) ;
uint8   PWMIN1_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define PWMIN1_DRIVE_MODE_BITS        (3)
#define PWMIN1_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - PWMIN1_DRIVE_MODE_BITS))
#define PWMIN1_DRIVE_MODE_SHIFT       (0x00u)
#define PWMIN1_DRIVE_MODE_MASK        (0x07u << PWMIN1_DRIVE_MODE_SHIFT)

#define PWMIN1_DM_ALG_HIZ         (0x00u << PWMIN1_DRIVE_MODE_SHIFT)
#define PWMIN1_DM_DIG_HIZ         (0x01u << PWMIN1_DRIVE_MODE_SHIFT)
#define PWMIN1_DM_RES_UP          (0x02u << PWMIN1_DRIVE_MODE_SHIFT)
#define PWMIN1_DM_RES_DWN         (0x03u << PWMIN1_DRIVE_MODE_SHIFT)
#define PWMIN1_DM_OD_LO           (0x04u << PWMIN1_DRIVE_MODE_SHIFT)
#define PWMIN1_DM_OD_HI           (0x05u << PWMIN1_DRIVE_MODE_SHIFT)
#define PWMIN1_DM_STRONG          (0x06u << PWMIN1_DRIVE_MODE_SHIFT)
#define PWMIN1_DM_RES_UPDWN       (0x07u << PWMIN1_DRIVE_MODE_SHIFT)

/* Digital Port Constants */
#define PWMIN1_MASK               PWMIN1__MASK
#define PWMIN1_SHIFT              PWMIN1__SHIFT
#define PWMIN1_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define PWMIN1_PS                     (* (reg32 *) PWMIN1__PS)
/* Port Configuration */
#define PWMIN1_PC                     (* (reg32 *) PWMIN1__PC)
/* Data Register */
#define PWMIN1_DR                     (* (reg32 *) PWMIN1__DR)
/* Input Buffer Disable Override */
#define PWMIN1_INP_DIS                (* (reg32 *) PWMIN1__PC2)


#if defined(PWMIN1__INTSTAT)  /* Interrupt Registers */

    #define PWMIN1_INTSTAT                (* (reg32 *) PWMIN1__INTSTAT)

#endif /* Interrupt Registers */

#endif /* End Pins PWMIN1_H */


/* [] END OF FILE */
