/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <project.h>
#include <stdio.h>
#include <stdlib.h>
#include <cytypes.h>

volatile uint16 PulseHighTime       = 0;	// pulsetime capture
volatile uint16 PulsePeriodStart    = 0;	// period time capture start
volatile uint16 PulsePeriodEnd      = 0;	// period time capture end

volatile uint8 flgPerdstart         = 0;    // Flag indicating + edge of pulse in has occured
volatile uint8 flgPerdend           = 0;    // Flag indicating + edge of next pulse has occured, signifying end of pepriod

float dutycycle                     = 0.0;  // Variable to hold duty cycle computation
float pulseperd                     = 0.0;  // Pulse period in mS

uint16 perdcalc                     = 0;    // Intermediate value to aid in period measurement
float dutycalc                     = 0;    // Intermediate value to aid in duty cycle measurement

int main()
{   
    PeriodISR_Start();		                // Start period time ISR
    PulsehiISR_Start();	                    // Start high pulse time ISR
    Counter_Start();		                // Start measurement counter
	
    CyGlobalIntEnable;                      // Uncomment this line to enable global interrupts
    
    for(;;)	{				                // Infinite for-loop

        if ( ( flgPerdstart == 1 ) && ( flgPerdend == 1 ) ) {
            
            // Test for counter rollover
            perdcalc = ( PulsePeriodEnd < PulsePeriodStart ) ? PulsePeriodStart - PulsePeriodEnd : PulsePeriodStart + ( 65535 - PulsePeriodEnd );
            dutycalc = (PulseHighTime < PulsePeriodStart ) ? PulsePeriodStart - PulseHighTime : PulseHighTime + ( 65535 - PulsePeriodStart);
            
            dutycycle = ( dutycalc * 100 ) / perdcalc;

            flgPerdstart = 0;    // Reset flags so another measurment can be initiated
            flgPerdend   = 0;
        }
		
		//CyDelay(500); // for debug purpose, time to read lcd
    }	// end of infinity for-loop

}	// end of main

/* [] END OF FILE */
